#pragma once
struct SpriteDataContext;
class CD3D11Sprite
{
public:
	CD3D11Sprite(void);
	virtual ~CD3D11Sprite(void);
	virtual void	SetTexture(INT no, TCHAR *pFilename);
	virtual HRESULT RestoreDeviceObjects(ID3D11DeviceContext *pContext);
	virtual HRESULT ReleaseDeviceObjects();
	virtual void    Render(ID3D11DeviceContext *pContext, FLOAT x, FLOAT y, FLOAT w, FLOAT h, INT no);
	virtual void    Render(ID3D11DeviceContext *pContext, FLOAT x, FLOAT y, FLOAT w, FLOAT h, FLOAT tx, FLOAT ty, FLOAT tw, FLOAT th, INT no);
	virtual void	SetDiffuse(FLOAT r, FLOAT g, FLOAT b, FLOAT a);
	virtual INT		GetNumTextures();

	//  keep 16-byte aligned
	void *operator new(size_t size){
		return _mm_malloc(size,16);
	}
	void operator delete(void *p){
		return _mm_free(p);
	}

protected:
	HRESULT CompileShaderFromMemory(BYTE *code, DWORD dwSize, LPCSTR szEntryPoint,LPCSTR szShaderModel, ID3DBlob **ppBlobOut);

	void InitFields();
	SpriteDataContext   *m_pDataContext;
	ID3D11DeviceContext	*m_pDeviceContext;
	ID3D11Device        *m_pDevice;
	ID3D11SamplerState	*m_pTextureSamplerState;
	ID3D11VertexShader	*m_pVertexShader;
	ID3D11PixelShader	*m_pPixelShader;
	ID3D11PixelShader	*m_pPixelShaderNoTex;
	ID3D11InputLayout	*m_pInputLayout;
	ID3D11BlendState	*m_pBlendState;

	ID3D11Buffer		*m_pVertexBuffer;
	ID3D11Buffer		*m_pConstantBuffer;

	DirectX::XMMATRIX	m_matProj;
	DirectX::XMFLOAT4   m_vecDiffuse;
};

