//----------------------------------------------------------
//
//  Application
//    DX11_Sprite
//
//  First Edition : October 21 2016
//  Author Mr.K
//
#include "stdafx.h"
#include "DX11_Sprite.h"
#include <stdio.h>
#include <crtdbg.h>
#include <D3D11.h>
#include <directxmath.h>
#include <D3Dcompiler.h>

using namespace DirectX;
#include "TextureLoader.h"
#include "D3D11Sprite.h"
#include "D3D11Font.h"

//  import libraries
#pragma comment(lib,"d3d11.lib")
#pragma comment(lib,"d3dcompiler.lib")

#define MAX_LOADSTRING 100

#define SAFE_DELETE(o)       if (o){  delete (o);  o = NULL;    }
#define SAFE_DELETE_ARRAY(o) if (o){  delete [] (o);  o = NULL; }
#define SAFE_RELEASE(o) if(o){  (o)->Release(); o = NULL; }

//	Globals

//
//  prototypes
//
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
HRESULT GetBackBufferSize(IDXGISwapChain *pSwapChain, DWORD *pWidth, DWORD *pHeight);
HRESULT	CreateDepthStencilView(
	ID3D11Device		*pDevice,
	INT	width,
	INT height,
	DXGI_FORMAT fmtDepthStencil,
	ID3D11DepthStencilView		**ppDepthStencilView,
	ID3D11Texture2D				**ppDepthStencilTexture,
	ID3D11ShaderResourceView	**ppDepthStencilShaderResourceView
);
HRESULT CreateRenderTargetView(
	ID3D11Device		*pDevice,
	IDXGISwapChain		*pSwapChain,
	ID3D11RenderTargetView	**ppRenderTargetView,
	ID3D11ShaderResourceView	**ppRenderTargetShaderResourceView
);
HRESULT CreateDeviceContextAndSwapChain(
	HWND				hWnd,
	ID3D11Device		**ppDevice,		
	ID3D11DeviceContext	**ppContext,	
	IDXGISwapChain		**ppSwapChain,
	D3D_DRIVER_TYPE		*pDriverType,
	D3D_FEATURE_LEVEL	*pFeatureLevel
);

TCHAR *GetDriverTypeText(D3D_DRIVER_TYPE dt);
TCHAR *GetFeatureLevelText(D3D_FEATURE_LEVEL fl);

//
//	WinMain
//	the entry point of windows application
//
int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
    _CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );

	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	MSG msg;

    //  ϐ錾
    WNDCLASSEX wcex;  //  EBhENX\
    HWND hWnd;        //  EBhEnh
    RECT    bounds,client;  //  RECT \

	//  (1)-a EBhENX̓o^
    wcex.cbSize = sizeof(WNDCLASSEX); 
    wcex.style          = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;  //  EBhEvV[W̓o^
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = hInstance;  //  AvP[VCX^X
    wcex.hIcon          = LoadIcon(NULL, MAKEINTRESOURCE(IDI_APPLICATION));
    wcex.hCursor        = LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
    wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = NULL;
    wcex.lpszClassName  = _T("D3D11_Sprite");  //  EBhENX
    wcex.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);
    RegisterClassEx(&wcex);
 
    //  (1)-b EBhE̐
    hWnd = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW,wcex.lpszClassName,_T("D3D11_Sprite"),
                WS_VISIBLE|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX,
                CW_USEDEFAULT,0,640,480,NULL,NULL,hInstance,NULL);
    if( !hWnd )
        return FALSE;

    //  EBhETCY̒
    //  ͖Ă
    GetWindowRect(hWnd,&bounds);
    GetClientRect(hWnd,&client);
    MoveWindow(hWnd,bounds.left,bounds.top,
        640 * 2 - client.right,
        480 * 2 - client.bottom,
        false );

    //  EBhE̍ĕ\
    ShowWindow( hWnd, nCmdShow );
    UpdateWindow( hWnd );

	//==========Direct3D11 ̏===================

	CoInitializeEx(NULL,COINIT_APARTMENTTHREADED);		//  COM 

	D3D_DRIVER_TYPE DriverType = D3D_DRIVER_TYPE_NULL;

    ID3D11DeviceContext      *pContext = NULL;              //  `
    ID3D11Device             *pDevice = NULL;               //  zA_v^in[hEGAj
    IDXGISwapChain           *pSwapChain = NULL;            //  Xbv`FC
    ID3D11RenderTargetView   *pRenderTargetView = NULL;     //  _[^[Qbg
    ID3D11DepthStencilView   *pDepthStencilView = NULL;     //  [xXeVobt@

    ID3D11Texture2D          *pDepthStencilTexture = NULL;            //  [xXeVT[tFCX
    ID3D11ShaderResourceView *pRenderTargetShaderResourceView = NULL; //  RenderTarget TextureSampler ANZX\ɂĂ
    ID3D11ShaderResourceView *pDepthStencilShaderResourceView = NULL; //  DepthStencil TextureSampler ANZX\ɂĂ

	D3D_FEATURE_LEVEL	FeatureLevel;

	D3D11_VIEWPORT vp;
	DWORD        width, height;     //  Screen width, Screen height
	CD3D11Font   *pFont = NULL;     //  D3DFont
	CD3D11Sprite *pSprite = NULL;   //	Sprite
	HRESULT      hr;

	//  foCXƃXbv`FC𐶐
	hr = CreateDeviceContextAndSwapChain(hWnd,&pDevice,&pContext,&pSwapChain,&DriverType,&FeatureLevel);
    if ( FAILED( hr ) )
		goto ERROR_EXIT;

	//  RenderTaget 𐶐
	hr = CreateRenderTargetView(pDevice,pSwapChain,&pRenderTargetView,&pRenderTargetShaderResourceView);
    if ( FAILED( hr ) )
		goto ERROR_EXIT;

	//  [xXeVobt@̂ Backbuffer ̃TCY擾
	hr = GetBackBufferSize(pSwapChain,&width, &height);
    if ( FAILED( hr ) )
		goto ERROR_EXIT;

	//  TCYƃtH[}bgw肵āA[xXeVobt@𐶐
	hr = CreateDepthStencilView(pDevice,width,height,DXGI_FORMAT_D16_UNORM,&pDepthStencilView,&pDepthStencilTexture,&pDepthStencilShaderResourceView);
    if ( FAILED( hr ) )
		goto ERROR_EXIT;

	//  foCXReLXgɃ_[^[QbgƐ[xXeVݒ
	pContext->OMSetRenderTargets( 1, &pRenderTargetView,pDepthStencilView);

	// r[|[g̐ݒ.
	vp.Width    = (FLOAT)width;
	vp.Height   = (FLOAT)height;
	vp.MinDepth = 0.0f;
	vp.MaxDepth = 1.0f;
	vp.TopLeftX = 0;
	vp.TopLeftY = 0;

	// foCXReLXgɃr[|[gݒ.
	pContext->RSSetViewports( 1, &vp );

	//==========eIuWFNg===================

	//  XvCg̍쐬
	CTextureLoader::Initialize();
	pSprite = new CD3D11Sprite();
	pSprite->SetTexture(0,_T("res\\smile2.rle.tga"));
	pSprite->RestoreDeviceObjects(pContext);

	//  tHg̍쐬
	pFont = new CD3D11Font(pContext);

	//  fobO\̗p
	TCHAR *pDriverType = ::GetDriverTypeText(DriverType);
	TCHAR *pFeatureLevel = GetFeatureLevelText(FeatureLevel);;
	unsigned int uiCount=0;

	//=================================================

	// C bZ[W [v:
    //  (2)bZ[W[v
    FLOAT	fAngle = 0;
	while(true){
        if(PeekMessage(&msg, 0, 0, 0, PM_REMOVE)){
            if(msg.message == WM_QUIT)
                break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }else{
			// wFŉʃNA
			float ClearColor[4] = { 0.0f, 0.125f, 0.3f, 1.0f }; //red,green,blue,alpha
			//float ClearColor[4] = { 0.0f, 0.0f, 0.0f, 1.0f }; //red,green,blue,alpha
			pContext->ClearRenderTargetView( pRenderTargetView, ClearColor );
			pContext->ClearDepthStencilView( pDepthStencilView, D3D11_CLEAR_DEPTH | D3D11_CLEAR_STENCIL, 1.0f, 0 );

			//  XvCg`
			static int k = 0, animframe;
			pSprite->SetDiffuse(1.0f,1.0f,1.0f,1.0f);
			pSprite->Render(pContext,64.0f,100.0f,256.0f,256.0f,0);	//  摜S̕`
			k = (k+1) % 120;
			animframe = 0;
			if (k >= 96){
				animframe = (k - 96)/6;
				if (animframe >= 4){
					animframe = 6 - animframe;
				}
			}

			//  摜ꕔ`
			pSprite->Render(pContext,400.0f,210.0f,64.0f,64.0f,animframe*64.0f,0.0f,64.0f,64.0f,0);

			//  tHg`
			FLOAT x = 0.0f, y = 0.0f;
			TCHAR tmp[32];
			int frame, sec, min, hour, day;
			frame = uiCount % 60;
			sec = (uiCount / 60) % 60;
			min = (uiCount / 3600) % 60;
			hour = (uiCount / (3600*60)) % 24;
			day =  (uiCount / (3600*60*24)) % 99;
			_stprintf_s(tmp,_T("%02d:%02d:%02d:%02d:%02d"),day,hour,min,sec,frame);
			pFont->DrawAnkText(pContext,tmp,XMFLOAT4(1.0f,1.0f,1.0f,0.75f),x,y);
			pFont->DrawAnkText(pContext,pDriverType,XMFLOAT4(1.0f,0.25f,0.25f,1.0f),x,y+=24.f);
			pFont->DrawAnkText(pContext,pFeatureLevel,XMFLOAT4(0.25f,1.0f,0.25f,1.0f),x,y+=24.f);
			uiCount++;
			//ʂEChEɔf
			if (FAILED(hr = pSwapChain->Present( 1, 0 ))){
				//  foCXXgւ̑Ώ͉\Ał͒PɏI鎖ɂ
				if (hr == DXGI_ERROR_DEVICE_RESET || hr == DXGI_ERROR_DEVICE_REMOVED){
					MessageBox(NULL,_T("Device ܂̂ŏI܂"),_T("Assert"),MB_OK);
					break;
				}
			}
        }
    }

ERROR_EXIT:
	CTextureLoader::Destroy();
	if (pSprite != NULL){
		delete pSprite;
		pSprite = NULL;
	}
	if (pFont != NULL){
		delete	pFont;
		pFont = NULL;
	}

	if (pContext){
		pContext->ClearState();
		pContext->Flush();
	}

	SAFE_RELEASE(pRenderTargetShaderResourceView);
	SAFE_RELEASE(pDepthStencilTexture);
	SAFE_RELEASE(pDepthStencilShaderResourceView);
	SAFE_RELEASE(pRenderTargetView);
	SAFE_RELEASE(pDepthStencilView);
	SAFE_RELEASE(pSwapChain);
	SAFE_RELEASE(pContext);
	SAFE_RELEASE(pDevice);

	CoUninitialize();	//  COM ̏I

	return (int) msg.wParam;
}




//
//	֐FWndProc
//	FEChEɓnꂽCxg̃nh
//
LRESULT CALLBACK WndProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam)
{

    switch (message){
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return    0;
}

//====================================================================================
//
//	Create DeviceContext and SwapChain
//	@param :
//		hWnd : (in)window's handle
//		ppDevice : (out)created device
//		ppContext : (out)created device context
//		ppSwapChain : (out)swap chain
//		pDriverType : (out)device's driver type
//		pFeatureLevel : (out)device's feature level
//
HRESULT CreateDeviceContextAndSwapChain(
	HWND				hWnd,
	ID3D11Device		**ppDevice,		
	ID3D11DeviceContext	**ppContext,	
	IDXGISwapChain		**ppSwapChain,
	D3D_DRIVER_TYPE		*pDriverType,
	D3D_FEATURE_LEVEL	*pFeatureLevel
){
	HRESULT hr = E_FAIL;

    // foCXtO.
    UINT createDeviceFlags = 0;

    // hCo[^Cv
    D3D_DRIVER_TYPE driverTypes[] = {
        D3D_DRIVER_TYPE_HARDWARE,
        D3D_DRIVER_TYPE_WARP,
        D3D_DRIVER_TYPE_REFERENCE,
    };
    UINT numDriverTytpes = sizeof( driverTypes ) / sizeof( driverTypes[0] );

    // @\x
    static const D3D_FEATURE_LEVEL featureLevels[] = {
        D3D_FEATURE_LEVEL_11_0,
        D3D_FEATURE_LEVEL_10_1,
        D3D_FEATURE_LEVEL_10_0,
    };
    UINT numFeatureLevels = sizeof( featureLevels ) / sizeof( featureLevels[0] );
	RECT rc;
	GetClientRect( hWnd, &rc );
	UINT width = rc.right - rc.left;
	UINT height = rc.bottom - rc.top;

	// Xbv`FC̍\ݒ.
    DXGI_SWAP_CHAIN_DESC sd;
    ZeroMemory( &sd, sizeof(DXGI_SWAP_CHAIN_DESC) );
    sd.BufferCount                          = 1;
    sd.BufferDesc.Width                     = width;
    sd.BufferDesc.Height                    = height;
    sd.BufferDesc.Format                    = DXGI_FORMAT_R8G8B8A8_UNORM;
    sd.BufferDesc.RefreshRate.Numerator     = 60;
    sd.BufferDesc.RefreshRate.Denominator   = 1;
    sd.BufferUsage                          = DXGI_USAGE_RENDER_TARGET_OUTPUT | DXGI_USAGE_SHADER_INPUT;
    sd.OutputWindow                         = hWnd;
    sd.SampleDesc.Count                     = 1;
    sd.SampleDesc.Quality                   = 0;
    sd.Windowed                             = TRUE;

	for( UINT idx = 0; idx < numDriverTytpes; ++idx ){
        // hCo[^Cvݒ.
        D3D_DRIVER_TYPE DriverType = driverTypes[ idx ];
  
        // foCXƃXbv`FC̐.
        hr = D3D11CreateDeviceAndSwapChain(
            NULL, 
            DriverType,
            NULL,
            createDeviceFlags,
            featureLevels,
            numFeatureLevels,
            D3D11_SDK_VERSION,
            &sd,
            ppSwapChain,
            ppDevice,
            pFeatureLevel,
            ppContext 
        );
		*pDriverType = DriverType;

        // 烋[vEo.
        if ( SUCCEEDED( hr ) )
			break; 
    }

	return hr;
}

//=========================================================
//
//	Create Render Target
//	@param :
//		pDevice    : (in)Direct3D device object
//		pSwapChain : (in)device's swap chain
//		ppRenderTargetView : (out)Created render target view
//		ppRenderTargetShaderResourceView : (out)render target's shader resource view
//
HRESULT CreateRenderTargetView(
	ID3D11Device		*pDevice,
	IDXGISwapChain		*pSwapChain,
	ID3D11RenderTargetView	**ppRenderTargetView,
	ID3D11ShaderResourceView	**ppRenderTargetShaderResourceView
){
	ID3D11Texture2D	*pBackBuffer = NULL;
	HRESULT hr = E_FAIL;

	//  Xbv`FCobNobt@擾.
    hr = pSwapChain->GetBuffer( 0, __uuidof( ID3D11Texture2D ), (LPVOID*)&pBackBuffer );
    if ( FAILED( hr ) )
		goto ERROR_EXIT;

	//	obNobt@A_[^[Qbg𐶐.
    hr = pDevice->CreateRenderTargetView( pBackBuffer, NULL, ppRenderTargetView );
    if ( FAILED( hr ) )
		goto ERROR_EXIT;

	// _[^[Qbg̃VF[_\[Xr[𐶐.
    hr = pDevice->CreateShaderResourceView( pBackBuffer, NULL, ppRenderTargetShaderResourceView );
    if ( FAILED( hr ) )
		goto ERROR_EXIT;

ERROR_EXIT:
	SAFE_RELEASE(pBackBuffer);	//	obNobt@J

	return hr;
}

//=========================================================
//
//	create depth-stencil view
//	@param :
//		pDevice : (in)Direct3D device
//		width   : (in)screen width
//		height  : (in)screen height
//      fmtDepthStencil    : (in)depth stencil format.
//		ppDepthStencilView : (out)depth stencil buffer
//		ppDepthStencilTexture : (out)depth stencil surface texture
//		ppDepthStencilShaderResourceView : (out)depth-stencil's shader resource view
//		
HRESULT	CreateDepthStencilView(
	ID3D11Device		*pDevice,
	INT	width,
	INT height,
	DXGI_FORMAT fmtDepthStencil,
	ID3D11DepthStencilView		**ppDepthStencilView,
	ID3D11Texture2D				**ppDepthStencilTexture,
	ID3D11ShaderResourceView	**ppDepthStencilShaderResourceView
){
    DXGI_FORMAT textureFormat   = DXGI_FORMAT_R16_TYPELESS;
    DXGI_FORMAT resourceFormat  = DXGI_FORMAT_R16_UNORM;
	HRESULT hr = E_FAIL;

    // eNX`ƃVF[_\[Xr[̃tH[}bgK؂Ȃ̂ɕύX.
    switch( fmtDepthStencil )
    {
    case DXGI_FORMAT_D16_UNORM:
        textureFormat  = DXGI_FORMAT_R16_TYPELESS;
        resourceFormat = DXGI_FORMAT_R16_UNORM;
        break;
  
    case DXGI_FORMAT_D24_UNORM_S8_UINT:
        textureFormat  = DXGI_FORMAT_R24G8_TYPELESS;
        resourceFormat = DXGI_FORMAT_R24_UNORM_X8_TYPELESS;
        break;
  
    case DXGI_FORMAT_D32_FLOAT:
        textureFormat  = DXGI_FORMAT_R32_TYPELESS;
        resourceFormat = DXGI_FORMAT_R32_FLOAT;
        break;
  
    case DXGI_FORMAT_D32_FLOAT_S8X24_UINT:
        textureFormat  = DXGI_FORMAT_R32G8X24_TYPELESS;
        resourceFormat = DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS;
        break;
	default:
		hr = E_FAIL;
		goto ERROR_EXIT;
    }
  
    //	[xXeVeNX`̐.
    D3D11_TEXTURE2D_DESC td;
    ZeroMemory( &td, sizeof( D3D11_TEXTURE2D_DESC ) );
    td.Width                = width;
    td.Height               = height;
    td.MipLevels            = 1;
    td.ArraySize            = 1;
    td.Format               = textureFormat;
    td.SampleDesc.Count     = 1;	//	MULTI SAMPLE COUNT
    td.SampleDesc.Quality   = 0;	//	MULtI SAMPLE QUALITY
    td.Usage                = D3D11_USAGE_DEFAULT;
    td.BindFlags            = D3D11_BIND_DEPTH_STENCIL | D3D11_BIND_SHADER_RESOURCE;
    td.CPUAccessFlags       = 0;
    td.MiscFlags            = 0;
  
    // [xXeVeNX`̐.
    hr = pDevice->CreateTexture2D( &td, NULL, ppDepthStencilTexture );
    if ( FAILED( hr ) )
		goto ERROR_EXIT;
  
    // [xXeVr[̐ݒ.
    D3D11_DEPTH_STENCIL_VIEW_DESC dsvd;
    ZeroMemory( &dsvd, sizeof( D3D11_DEPTH_STENCIL_VIEW_DESC ) );
    dsvd.Format         = fmtDepthStencil;
    if ( td.SampleDesc.Count == 0 )
    {
        dsvd.ViewDimension      = D3D11_DSV_DIMENSION_TEXTURE2D;
        dsvd.Texture2D.MipSlice = 0;
    }
    else
    {
        dsvd.ViewDimension = D3D11_DSV_DIMENSION_TEXTURE2DMS;
    }
  
    // [xXeVr[̐.
    hr = pDevice->CreateDepthStencilView( *ppDepthStencilTexture, &dsvd, ppDepthStencilView );
    if ( FAILED( hr ) )
    {
	  goto ERROR_EXIT;
    }

    // VF[_\[Xr[̐ݒ.
    D3D11_SHADER_RESOURCE_VIEW_DESC srvd;
    ZeroMemory( &srvd, sizeof( D3D11_SHADER_RESOURCE_VIEW_DESC ) );
    srvd.Format                     = resourceFormat;
  
    if ( td.SampleDesc.Count == 0 )
    {
        srvd.ViewDimension              = D3D11_SRV_DIMENSION_TEXTURE2D;
        srvd.Texture2D.MostDetailedMip  = 0;
        srvd.Texture2D.MipLevels        = 1;
    }
    else
    {
        srvd.ViewDimension = D3D11_SRV_DIMENSION_TEXTURE2DMS;
    }
  
    // VF[_\[Xr[𐶐.
    hr = pDevice->CreateShaderResourceView( *ppDepthStencilTexture, &srvd, ppDepthStencilShaderResourceView );
    if ( FAILED( hr ) )
    { 
	  goto ERROR_EXIT;
    }
ERROR_EXIT:
	return hr;
}

//=========================================================
//
//	Get back-buffer size from swap chain
//	@param :
//		pSwapChain : (in)swap chain
//		pWidth     : (out)back-buffer width
//		pHeight    : (out)back-buffer height]
//
HRESULT GetBackBufferSize(IDXGISwapChain *pSwapChain, DWORD *pWidth, DWORD *pHeight){
	ID3D11Texture2D	*pBackBuffer = NULL;
	HRESULT hr = E_FAIL;
	D3D11_TEXTURE2D_DESC desc;
	//  Xbv`FCobNobt@擾.
    hr = pSwapChain->GetBuffer( 0, __uuidof( ID3D11Texture2D ), (LPVOID*)&pBackBuffer );
    if ( FAILED( hr ) )
		goto ERROR_EXIT;
	pBackBuffer->GetDesc(&desc);

	*pWidth  = (DWORD)desc.Width;
	*pHeight = (DWORD)desc.Height;
	hr = S_OK;

ERROR_EXIT:
	SAFE_RELEASE(pBackBuffer);
	return hr;
}

//=========================================================
//
//  Debug utility
//  Get the name of driver type
//
TCHAR *GetDriverTypeText(D3D_DRIVER_TYPE dt){
	switch(dt){
	case	D3D_DRIVER_TYPE_UNKNOWN:
		return _T("D3D_DRIVER_TYPE_UNKNOWN");
	case	D3D_DRIVER_TYPE_HARDWARE:	
		return _T("D3D_DRIVER_TYPE_HARDWARE");
	case	D3D_DRIVER_TYPE_REFERENCE:
		return _T("D3D_DRIVER_TYPE_REFERENCE");
	case	D3D_DRIVER_TYPE_NULL:
		return _T("D3D_DRIVER_TYPE_NULL");
	case	D3D_DRIVER_TYPE_SOFTWARE:	
		return _T("D3D_DRIVER_TYPE_SOFTWARE");
	case	D3D_DRIVER_TYPE_WARP:		
		return _T("D3D_DRIVER_TYPE_WARP");
	}
	return NULL;
}

//=========================================================
//
//  Debug utility
//  Get the name of feature level
//
TCHAR *GetFeatureLevelText(D3D_FEATURE_LEVEL fl){
	switch(fl){
	case	D3D_FEATURE_LEVEL_9_1:	
		return _T("D3D_FEATURE_LEVEL_9_1");
	case	D3D_FEATURE_LEVEL_9_2:	
		return _T("D3D_FEATURE_LEVEL_9_2");
	case	D3D_FEATURE_LEVEL_9_3:
		return _T("D3D_FEATURE_LEVEL_9_3");
	case	D3D_FEATURE_LEVEL_10_0:
		return _T("D3D_FEATURE_LEVEL_10_0");
	case	D3D_FEATURE_LEVEL_10_1:
		return _T("D3D_FEATURE_LEVEL_10_1");
	case	D3D_FEATURE_LEVEL_11_0:
		return _T("D3D_FEATURE_LEVEL_11_0");
	}
	return NULL;
}
